Index: trunk/tools/generic_tools.py
===================================================================
--- trunk/tools/generic_tools.py	(revision 849)
+++ trunk/tools/generic_tools.py	(revision 850)
@@ -2975,4 +2975,20 @@
     return
 
+def singleline_printing_class(classobj):
+    """ Function to print all the values of a given class in a single line to be parseavel
+      output as: 'singleline_printing_class[attrval]';'[attrval]';'...
+        [attrval] = @'[attribute]'@:'[value]('!' for spaces)
+    """
+    fname='singleline_printing_class'
+
+    valscls = vars(classobj)
+    sline=fname + ' '
+
+    for attrcls in valscls:
+        sline = sline + '@' + attrcls + '@:' + str(valscls[attrcls]).replace(' ','!') + ";"
+
+    print sline
+    return
+
 def cycl_incr(cyclval,cycle,ninc):
     """ Function to increment a cyclic value [cyclval] with a cycle [cycle] a given number [ninc] of times
Index: trunk/tools/nc_var_tools.py
===================================================================
--- trunk/tools/nc_var_tools.py	(revision 849)
+++ trunk/tools/nc_var_tools.py	(revision 850)
@@ -15252,109 +15252,7 @@
     modchar = ModelChar(model,ncfile)
     gen.printing_class(modchar)
+    gen.singleline_printing_class(modchar)
 
     return
 
 #quit()
-
-"""operation to make: 
-  addfattr, add a attributes to a variable from another file: addfattr -S [file]:[var] 
-  addfdim, add a new dimension from another file: addfdim -S [file]:[dimension] 
-  addfgattr, add global attribute from another file: addfgattr -S [file]
-  addfvar, add a new variable from another file: addfvar -S [file]:[variable] 
-  addgattr, add a new global attribute: addatr -S [attrname]|[attrvalue]
-  addgattrk, add a new global attribute: addatr -S [attrname]|[attrvalue]|[kind(S (!, white spaces),I,R,D)]
-  addref, add a new variable with dimension and attributes from an already existing 'variable ref' in the file: addref -S [variable ref]:[attr name]@[value]:[[attr2]@[value2], ...]:[value/file with values]  mname, modify name -S newname
-  addvals, Function to add values to a given variable at a given dimension: addvals -S [dimension]:[position]:[Nvals]:[addval], 
-    *[position]: position within the dimension at which the variable wants to be increased
-       'first': first position of the dimension
-       'middle': middle position of the dimension
-       'last': last position of the dimension
-       'num': before given value
-    *[addval]: value to give to the added values
-       'val': a given value
-       'missing': as a missing value
-  addvattr, add a new attribute to any given variable: addvattr -S [attrname]|[attrvalue]
-  addvattrk, add a new attribute to any given variable: addvattr
-k -S [attrname]|[attrvalue]|[kind(S (!, white spaces),I,R,D)]
-  checkNaNs, checks for NaN values over all variables in a file
-  checkAllValues, check for variables with along all their dimensions with the same value in a file
-  flipdim, flips the value following one dimension: flipdim -S Ndim
-  infgattrs, give the values of all the global attributes of the file: infgattrs
-  infsinggattrs, give the value of a single global attribute of the file: infsinggattrs -S [attribute name]
-  infsingvattrs, give the value of a single attribute of the variable: infsingvattrs -S [attribute name]
-  inftime, give all the information of the variable time: inftime
-  infvars, give the names of all the variables of the file: infvars
-  infvattrs, give the values of all the attributes of a variable: infvattrs
-  mdname, modify dimension name: mdname -S olddname:newdname
-  means, computes the spatial mean of the variable: means
-  meanseas, compute the seasonal mean of a variable: meanseas -S [timename]
-  meant, computes the temporal mean of the variable: meant -S [power](power of the polynomial fit)
-  mname, modify name: mname -S newname
-  out, output values: out -S inidim1,[inidim2,...]:enddim1,[enddim2,...]
-  rgattr, read a global attribute: rgattr -S [attrname]
-  rvattr, read a variable attribute: rvattr -S [attrname]
-  rmgattr, remove a global attribute: rmgattr -S [attrname]
-  rmvariable, remove a variable: rmvariable
-  rmvattr, remove an attribute to any given variable: rmvattr -S [attrname]
-  subsetmns, retrieve a subset of values based on months: subsetmns -S [MM1]:[...:[MMn]] or [MMi]-[MMe] for a period (output as 'subsetmns.nc')
-  subsetyrs, retrieve a subset of values based on years: subsetyrs -S [YYYY1]:[...:[YYYYn]] or [YYYYi]-[YYYYe] for a period (output as 'subsetyrs.nc')
-  timescheck, checks time-steps of a given file: timescheck -S [FirstDate]:[LastDate][freq]:[[auxmonth]]
-      [FirstDate] = first date within file (in [YYYY][MM][DD][HH][MI][SS] format)
-      [LastDate] = last date within file (in [YYYY][MM][DD][HH][MI][SS] format)
-      [freq] = frequency of the data within the file (in time units) or 'month' (monthly values)
-      [auxmonth] = in case of 'month'
-        midmon: dates are given according to the mid time value of the month
-        real: dates are given increassing a month from the previous date
-  timesort, sort a variable time: timesort
-  timestepchg, changes a time-step value from a file, using a given time-step from another one: timestepchg -S [origtime_step]:[newfile]:[newtime_step]
-  valmod, modifiy values of variable -S [modification]:
-     sumc,[constant]: add [constant] to variables values
-     subc,[constant]: substract [constant] to variables values
-     mulc,[constant]: multipy by [constant] to variables values
-     divc,[constant]: divide by [constant] to variables values
-     lowthres,[threshold],[newvalue]: modify all values below [threshold] to [newvalue]
-     upthres,[threshold],[newvalue]: modify all values above [threshold] to [newvalue]
-  valmod_dim(values, ncfile, varn)
-
-  vartimeshidft, temporaly shift a number of time-steps a given variable inside a netCDF file: vartimeshift -S [nsteps]:[[FillValue]]
-  varmask, mask a variable using a mask: varmask -S [maskfilename]:[maskvar]:[dimsmask]:[timename]. It is assumed that mask[...,dimM,dimJ,dimK] 
-    and var[...,dimM,dimJ,dimK] share the last dimensions
-
-'addfattr': fattradd(opts.varname, opts.values, opts.ncfile)
-'addfdim': fdimadd(opts.values, opts.ncfile)
-'addfgattr': fgaddattr(opts.values, opts.ncfile)
-'addfvar': fvaradd(opts.values, opts.ncfile)
-'addgattr': gaddattr(opts.values, opts.ncfile)
-'addgattrk': gaddattrk(opts.values, opts.ncfile)
-'addref': varaddref(opts.values, opts.ncfile, opts.varname)
-'addvattr': varaddattr(opts.values, opts.ncfile, opts.varname)
-'addvattrk': varaddattrk(opts.values, opts.ncfile, opts.varname)
-'DataSetSection': datasetsection(opts.values,opts.ncfile)
-'dimflip': flipdim(opts.values,opts.ncfile,opts.varname)
-'infgattrs': igattr(opts.ncfile)
-'infsinggattrs': isgattrs(opts.values, opts.ncfile)
-'infsingvattrs': isvattrs(opts.values, opts.ncfile, opts.varname)
-'inftime': timeinf(opts.ncfile, opts.varname)
-'infvars': ivars(opts.ncfile)
-'infvattrs': ivattr(opts.ncfile, opts.varname)
-'mdname': chdimname(opts.values, opts.ncfile, opts.varname)
-'means': spacemean(opts.ncfile, opts.varname)
-'meanseas': spacemean(opst.values, opts.ncfile, opts.varname)
-'meant': timemean(opts.values, opts.ncfile, opts.varname)
-'mname': chvarname(opts.values, opts.ncfile, opts.varname)
-'out': varout(opts.values, opts.ncfile, opts.varname)
-'rgattr': grattr(opts.values, opts.ncfile)
-'rvattr': vrattr(opts.values, opts.ncfile, opts.varname)
-'rmgattr': grmattr(opts.values, opts.ncfile)
-'rmvariable': varrm(opts.ncfile, opts.varname)
-'rmvattr': varrmattr(opts.values, opts.ncfile, opts.varname)
-'subsetmns': submns(opts.values, opts.ncfile, opts.varname)
-'subsetyrs': subyrs(opts.values, opts.ncfile, opts.varname)
-'timescheck': check_times_file(opts.values, opts.ncfile, opts.varname)
-'timesort': sorttimesmat(opts.ncfile, opts.varname)
-'timestepchg': chgtimestep(opts.values, opts.ncfile, opts.varname)
-'valsadd': addvals(opts.values, opts.ncfile, opts.varname)
-'valmod': valmod(opts.values, opts.ncfile, opts.varname)
-'varmask': maskvar(opts.values, opts.ncfile, opts.varname)
-'vartimeshift': timeshiftvar(opts.values, opts.ncfile, opts.varname)
-"""